"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Configuration = void 0;
var friendly_errors_webpack_plugin_1 = __importDefault(require("friendly-errors-webpack-plugin"));
var Configuration = (function () {
    function Configuration(config, mode) {
        this.config = config;
        this.mode = mode;
        this.config.addPlugin(new friendly_errors_webpack_plugin_1.default());
    }
    Configuration.prototype.exec = function () {
        var config = {
            context: this.config.getContext(),
            mode: this.mode || 'development',
            devtool: 'source-map',
            entry: this.config.getEntries(),
            output: this.config.getOutput(),
            module: {
                rules: this.config.getLoaders(),
            },
            plugins: this.config.getPlugins(),
            performance: {
                hints: false,
            },
            resolve: {
                extensions: this.config.getExtensions(),
                alias: this.config.getAliases(),
                modules: this.config.getResolvePaths(),
            },
            externals: this.config.getExternals(),
        };
        if (this.mode === 'development') {
            config.devtool = 'inline-source-map';
        }
        this.config.getConfigs().forEach(function (callback) {
            config = callback(config);
        });
        return config;
    };
    return Configuration;
}());
exports.Configuration = Configuration;
//# sourceMappingURL=configuration.js.map